
---
apiVersion: rke-machine-config.cattle.io/v1
kind: VmwarevsphereConfig
metadata:
  name: release-name-master
cfgparam:
- disk.enableUUID=TRUE
cloneFrom: /Datacenter01/vm/LAN/release-name/release-name-master
cloudConfig: |-
  #cloud-config
  bootcmd:
  - |
    # bootcmd is executed before write_files[]
    # hence, bootcmd script is unavailable during first boot
    # therefore, this is conditional, and first boot invocation is also handled in runcmd
    script="/etc/cloud/bootcmd.sh"
    if [ -f "$script" ]; then sudo bash -x "$script"; fi
  chpasswd:
    expire: false
  disk_setup: {}
  fs_setup: []
  mounts: []
  runcmd:
  - |
    # call runcmd script
    sudo bash -x /etc/cloud/runcmd.sh
    # bootmcd is not yet available during first boot, because it is executed before write_files[]
    # therefore we call it also from here
    sudo bash -x /etc/cloud/bootcmd.sh
  users: []
  write_files:
  - content: |
      #!/bin/bash

      # extract config from guestinfo
      vmtoolsd --cmd 'info-get guestinfo.ovfenv' > /tmp/ovfenv
      extract() { sed -nre 's/.*guestinfo.'$1'.*value="([^"]+)".*/\1/p' /tmp/ovfenv; }
      ip=$(extract ip)
      gw=$(extract gateway)
      nm=$(extract netmask)
      ns=$(extract dns)
      ipsuffix=${ip//*./}   # get last component in IPv4
      pnum=${ipsuffix:0:1}  # 1st number is a pool number
      nnum=${ipsuffix:1:2}  # remainder is a VM index
      hostname=$(hostname | sed -re 's/([^-]+)-([^-]+)-.*/\1'$pnum'\2'$nnum'/') # e.g. x.x.x.123 => pnum=1,nnum=23 => cluster1pool23
      tee $(ls -1 /etc/netplan/*.yaml | head -n1) <<EOF
      network:
        version: 2
        renderer: networkd
        ethernets:
          ens192:
            addresses: [ $ip/24 ]
            routes:
            - to: default
              via: $gw
            nameservers:
              addresses: [ $ns ]
      EOF

      # apply network config
      hostnamectl set-hostname $hostname
      netplan apply

      #https://askubuntu.com/questions/719058/blk-update-request-i-o-error-dev-fd0-sector-0
      rmmod floppy
      echo "blacklist floppy" | tee /etc/modprobe.d/blacklist-floppy.conf
      dpkg-reconfigure initramfs-tools

      #https://longhorn.io/kb/troubleshooting-volume-with-multipath/
      #https://github.com/longhorn/longhorn/issues/6755
      #https://github.com/kubernetes/kubernetes/issues/60894
      systemctl stop multipathd
      systemctl disable multipathd

      #kubectl
      curl -sL https://dl.k8s.io/release/v1.28.4/bin/linux/amd64/kubectl | install /dev/stdin /usr/local/bin/kubectl -m555

      #k9s
      curl -sL https://github.com/derailed/k9s/releases/download/v0.28.2/k9s_Linux_amd64.tar.gz | tar xzv -C /usr/local/bin k9s

      #KUBECONFIG
      tee -a /etc/environment <<EOF
      KUBECONFIG="/etc/rancher/rke2/rke2.yaml"
      EOF
    path: /etc/cloud/runcmd.sh
  - content: |
      #!/bin/bash
      fsresize() {
        local disk part
        if [[ "$1" =~ ([^0-9]+)([0-9]+)$ ]]; then
          disk=${BASH_REMATCH[1]}
          part=${BASH_REMATCH[2]}
        fi

        # validate
        [[ -b "${disk}${part}" ]] || return 1

        # resize partition and file system
        growpart "$disk" "$part"
        resize2fs "${disk}${part}"

        # report
        df -h "${disk}${part}"
      }

      fsresize_all() {
        for i in $(ls /dev/sd[b-z]1 2>/dev/null); do
          fsresize $i
        done
      }

      fsresize_all
    path: /etc/cloud/bootcmd.sh
cpuCount: "1"
creationType: template
datacenter: /Datacenter01
datastore: /Datacenter01/datastore/Datastore01
diskSize: "10000"
folder: /Datacenter01/vm/LAN/release-name
hostsystem: /Datacenter01/host/Esxi01/Esxi01
memorySize: "2000"
network:
- /Datacenter01/network/LAN/release-name/release-name-master
pool: /Datacenter01/host/Esxi01/Resources/LAN/release-name
vappProperty:
- guestinfo.ip=ip:release-name-master
- guestinfo.gateway=${gateway:release-name-master}
- guestinfo.netmask=${netmask:release-name-master}
- guestinfo.dns=${dns:release-name-master}
vappTransport: com.vmware.guestInfo
